;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Running Wanwan
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"
					LDA #$01
					STA $1467
					STA $1570,x
					LDA #$FF
					STA $1466
					STA $157C,x
					LDA #$01
					STA $1504,x
					LDA #$D0
					STA $151C,x
					LDA #$20
					STA $15AC,x
					STZ $1594,x
					RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; goomba main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN              RTS
CODE_START          JSR HDMA1
					LDA $9D
					BNE RETURN
					
					LDA $15AC,x
					BNE MAIN
					LDA #$07
					STA $1DFC
					LDA #$20
					STA $15AC,x
MAIN
					JSR LAYER2
					JSR DAMAGE
					LDA $94
					STA $E4,x
					LDA $95
					STA $14E0,x
					LDA $96
					STA $D8,x
					LDA $97
					STA $14D4,x
					RTS

LAYER2				
					LDA $157C,x
					SEC
					SBC #$02
					STA $157C,x
					LDA $1570,x
					SBC #$00
					STA $1570,x
					
					LDA $157C,x
					CLC
					ADC $1462
					STA $1466
					LDA $1570,x
					ADC $1463
					STA $1467
					
					LDA $1467
					CMP #$02
					BNE LAYER2_2
					LDA #$01
					STA $1467
					LDA #$FF
					STA $1466
					LDA $1466
					SEC
					SBC $1462
					STA $157C,x
					LDA $1467
					SBC $1463
					STA $1570,x
LAYER2_2			LDA $1467
					CMP #$FF
					BNE LAYER2_E
					STZ $1467
					STZ $1466
					LDA $1466
					SEC
					SBC $1462
					STA $157C,x
					LDA $1467
					SBC $1463
					STA $1570,x
LAYER2_E			RTS

DAMAGE				LDA $151C,x
					SEC
					SBC $157C,x
					STA $7FFD02
					LDA $1504,x
					SBC $1570,x
					STA $7FFD03
					CMP $95
					BNE CLASH
					LDA $7FFD02
					AND #$F0
					STA $7FFD0F
					LDA $94
					AND #$F0
					CMP $7FFD0F
					BNE CLASH
					LDA $1497
					BNE CLASH
					LDA $97
					BEQ CLASH
					LDA $96
					CMP #$20
					BCC CLASH
					JSL $00F5B7

CLASH				LDA $7FFD02
					CLC
					ADC #$20
					STA $7FFD02
					LDA $7FFD03
					ADC #$00
					STA $7FFD03
					CMP #$20
					BCS CLASH_E
					LDA $7FFD02
					STA $9A
					LDA $7FFD03
					STA $9B
					LDA #$01
					STA $99

					INC $1594,x
					LDA $1594,x
					AND #$01
					BEQ CLASH2
					LDA #$80
					STA $98
					JSR CHEANGE_TILE
					LDA #$70
					STA $98
					JSR CHEANGE_TILE
					LDA #$60
					STA $98
					JSR CHEANGE_TILE
CLASH_E				RTS
CLASH2				LDA #$50
					STA $98
					JSR CHEANGE_TILE
					LDA #$40
					STA $98
					JSR CHEANGE_TILE
					RTS

CHEANGE_TILE		         ;
					LDA #$01                ;
					STA $9C
					LDY #$00
                    JSL $00BEB0
					RTS

RETURN_H			RTS
HDMA1				
					LDA $7FFB28
					BNE RETURN_H

					LDA #$17
					STA $00212C
					LDA #$00
					STA $00212D

					LDA #$20
					STA $7FFB28
					LDA #$40
					STA $7FFB30
					
					LDA #$00
					STA $7FFB29
					LDA #$02
					STA $7FFB31
					
					LDA #$21
					STA $7FFB2A
					LDA #$22
					STA $7FFB32
					
					LDA #$00
					STA $7FFB2B
					STA $7FFB33
					LDA #$E1
					STA $7FFB2C
					LDA #$E2
					STA $7FFB34
					LDA #$7F
					STA $7FFB2D
					STA $7FFB35

HDMA1_1				LDA #$07
					STA $7FE100
					STA $7FE200
					LDA #$00
					STA $7FE101
					LDA #$DE
					STA $7FE201
					LDA #$50
					STA $7FE202
					
					LDA #$07
					STA $7FE102
					STA $7FE203
					LDA #$00
					STA $7FE103
					LDA #$FE
					STA $7FE204
					LDA #$50
					STA $7FE205
					
					LDA #$07
					STA $7FE104
					STA $7FE206
					LDA #$00
					STA $7FE105
					LDA #$1E
					STA $7FE207
					LDA #$51
					STA $7FE208
					
					LDA #$07
					STA $7FE106
					STA $7FE209
					LDA #$00
					STA $7FE107
					LDA #$3E
					STA $7FE20A
					LDA #$51
					STA $7FE20B
					
					LDA #$07
					STA $7FE108
					STA $7FE20C
					LDA #$00
					STA $7FE109
					LDA #$5E
					STA $7FE20D
					LDA #$51
					STA $7FE20E
					
					LDA #$07
					STA $7FE10A
					STA $7FE20F
					LDA #$00
					STA $7FE10B
					LDA #$7E
					STA $7FE210
					LDA #$51
					STA $7FE211
					
					LDA #$07
					STA $7FE10C
					STA $7FE212
					LDA #$00
					STA $7FE10D
					LDA #$9E
					STA $7FE213
					LDA #$51
					STA $7FE214
					
					LDA #$07
					STA $7FE10E
					STA $7FE215
					LDA #$00
					STA $7FE10F
					LDA #$BE
					STA $7FE216
					LDA #$51
					STA $7FE217
					
					LDA #$07
					STA $7FE110
					STA $7FE218
					LDA #$00
					STA $7FE111
					LDA #$DE
					STA $7FE219
					LDA #$51
					STA $7FE21A
					
					LDA #$07
					STA $7FE112
					STA $7FE21B
					LDA #$00
					STA $7FE113
					LDA #$FE
					STA $7FE21C
					LDA #$51
					STA $7FE21D
					
					LDA #$07
					STA $7FE114
					STA $7FE21E
					LDA #$00
					STA $7FE115
					LDA #$1E
					STA $7FE21F
					LDA #$52
					STA $7FE220
					
					LDA #$07
					STA $7FE116
					STA $7FE221
					LDA #$00
					STA $7FE117
					LDA #$3E
					STA $7FE222
					LDA #$52
					STA $7FE223
					
					LDA #$07
					STA $7FE118
					STA $7FE224
					LDA #$00
					STA $7FE119
					LDA #$5E
					STA $7FE225
					LDA #$52
					STA $7FE226
					
					LDA #$07
					STA $7FE11A
					STA $7FE227
					LDA #$00
					STA $7FE11B
					LDA #$7E
					STA $7FE228
					LDA #$52
					STA $7FE229
					
					LDA #$07
					STA $7FE11C
					STA $7FE22A
					LDA #$00
					STA $7FE11D
					LDA #$9E
					STA $7FE22B
					LDA #$52
					STA $7FE22C
					
					LDA #$07
					STA $7FE11E
					STA $7FE22D
					LDA #$00
					STA $7FE11F
					LDA #$BE
					STA $7FE22E
					LDA #$52
					STA $7FE22F
					
					LDA #$07
					STA $7FE120
					STA $7FE230
					LDA #$00
					STA $7FE121
					LDA #$DE
					STA $7FE231
					LDA #$52
					STA $7FE232
					
					LDA #$07
					STA $7FE122
					STA $7FE233
					LDA #$00
					STA $7FE123
					LDA #$FE
					STA $7FE234
					LDA #$52
					STA $7FE235
					
					LDA #$07
					STA $7FE124
					STA $7FE236
					LDA #$00
					STA $7FE125
					LDA #$1E
					STA $7FE237
					LDA #$53
					STA $7FE238
					
					LDA #$07
					STA $7FE126
					STA $7FE239
					LDA #$00
					STA $7FE127
					LDA #$3E
					STA $7FE23A
					LDA #$53
					STA $7FE23B
					
					LDA #$07
					STA $7FE128
					STA $7FE23C
					LDA #$00
					STA $7FE129
					LDA #$5E
					STA $7FE23D
					LDA #$53
					STA $7FE23E
					
					LDA #$07
					STA $7FE12A
					STA $7FE23F
					LDA #$00
					STA $7FE12B
					LDA #$7E
					STA $7FE240
					LDA #$53
					STA $7FE241
					
					LDA #$07
					STA $7FE12C
					STA $7FE242
					LDA #$00
					STA $7FE12D
					LDA #$9E
					STA $7FE243
					LDA #$53
					STA $7FE244
					
					LDA #$07
					STA $7FE12E
					STA $7FE245
					LDA #$00
					STA $7FE12F
					LDA #$BE
					STA $7FE246
					LDA #$53
					STA $7FE247
					
					LDA #$07
					STA $7FE130
					STA $7FE248
					LDA #$00
					STA $7FE131
					LDA #$DE
					STA $7FE249
					LDA #$53
					STA $7FE24A
					
					LDA #$07
					STA $7FE132
					STA $7FE24B
					LDA #$00
					STA $7FE133
					LDA #$FE
					STA $7FE24C
					LDA #$53
					STA $7FE24D
					
					LDA #$00
					STA $7FE134
					STA $7FE24E
					RTS
